﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_linked_list_primes
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            Cursor = Cursors.WaitCursor;
            txtResult.Clear();
            txtResult.Refresh();
            lblTime.Text = "";

            Cell sentinel = new Cell();
            Cell last_cell = sentinel.AddAfter(2);

            int max = int.Parse(txtMax.Text);

            Stopwatch watch = new Stopwatch();
            watch.Start();
            for (int i = 3; i <= max; i += 2)
            {
                // See if i is prime.
                bool is_prime = true;
                int sqrt_i = (int)Math.Sqrt(i);
                for (Cell c = sentinel.Next; c.Value <= sqrt_i; c = c.Next)
                {
                    // See if c divides evenly into i.
                    if (i % c.Value == 0)
                    {
                        // c divides evenly into i so i is not prime.
                        is_prime = false;
                        break;
                    }
                }
                if (is_prime) last_cell = last_cell.AddAfter(i);
            }
            watch.Stop();
            lblTime.Text = "Time: " +
                watch.Elapsed.TotalSeconds.ToString("0.00") +
                " seconds";

            // Display the result.
            StringBuilder sb = new StringBuilder();
            for (Cell c = sentinel.Next; c != null; c = c.Next)
            {
                sb.Append(c.Value.ToString());
                if (c.Next != null) sb.Append(" ");
                if (c.Value > 10000)
                {
                    sb.Append("...");
                    break;
                }
            }

            txtResult.Text = sb.ToString();
            Cursor = Cursors.Default;
        }
    }
}
